<?php
// --- Paths definitions --- //
$absolute = str_ireplace ('wp-content\plugins\dregister\ajax','',dirname(__FILE__));
$absolute = str_ireplace ('wp-content/plugins/dregister/ajax','',$absolute);
define( 'ABSPATH_ROOT',$absolute );
define( 'ABSPATH_PLUGINDIR',  str_ireplace ('ajax','',dirname(__FILE__)) );

include_once(ABSPATH_ROOT.'wp-load.php');
include_once(ABSPATH_PLUGINDIR.'/config/globals.php');

// !! Non loggato ---// 
if (!is_user_logged_in()):
	echo __('<p><strong>ERROR:</strong> You must log in first.</p>','dregister');
	die;
endif;
 
 // !! Non amministratore ---// 
if (!current_user_can('manage_options')):
	echo __('<p><strong>ERROR:</strong> You don\'t have administrator rights to modify registration options.</p>','dregister');
	die;
endif;

// -- Cancella opzioni ---// 
if(empty($_POST['fields']) ):	
	delete_option('dr_fields');
	die;
endif;


// -- Aggiorna opzioni ---// 
foreach ($_POST['fields'] as $k=>$v){
	# Opzione vuota
	if (empty($v['name'])):		
		echo __('<p><strong>ERROR:</strong> You cannot leave any blank field name.</p>','dregister');
		die;
	endif;
	
	$field_name = 'dr_'.ereg_replace("[^a-z0-9_]", "", strtolower($v['name']));
		
	$_POST['fields'][$k]['field_name'] = $field_name;

	$field_names[$k] = $field_name;
	$field_nicenames[$field_name] = $v['name'];
}
	# Opzione esistente	
	foreach ( array_count_values($field_names) as $k=>$v){		
		if ($v>1):
			echo __('<p><strong>ERROR:</strong> Field "<b>'.$field_nicenames[$k].'</b>" is already present. Try changing the name.</p>','dregister');
			die;		
		endif;
	}
	
update_option('dr_fields', $_POST['fields']);
update_option('dr_force_first_name',$_POST['dr_force_first_name']);
update_option('dr_force_last_name',$_POST['dr_force_last_name']);
	


?>
